// #autoload
// #name = TransVehChat
// #version = 1.0
// #date = June 21st, 2002
// #author = <spush><color:ffff00></a><a:tribe	The Ministry>min <color:ffffff><a:player	TruSoulja>TruSoulja</a><spop>
// #warrior = TruSoulja
// #email = trusoulja@zbzoom.net
// #ICQ = 11108946
// #web = http://www.isaboo.net/trusoulja
// #description = Makes the ChatHUD transparent when in a vehicle.  Requested by <spush><color:ffff00><a:tribe	The Ministry>min <color:ffffff><a:player	Pace>Pace</a><spop>
// #status = Release
// #readme = scripts/trusoulja/tvcreadme.txt
// #include = support/vehicle_callbacks.cs

function initTransVehChat() {
  // load prefs if they exist, write defaults otherwise
  if (isFile("prefs/truprefs.cs"))
    exec("prefs/truprefs.cs");

  if ($TruPref::transVehChatOn $= "")
    changeTVCSetting(1);

  // add callbacks used in support/vehicle_callbacks.cs
  callback.add(OnVehicleMount, vehMount);
  callback.add(OnVehicleDismount, vehDismount);

  $tvcPlayerPilot = false;
}

function changeTVCSetting(%val) {
  $TruPref::transVehChatOn = %val;
  export("$TruPref::*", "prefs/truprefs.cs", false);
}

// vehicle_callbacks.cs has a slight problem that doesn't allow
// you to check the current position at mount, since the position
// is saved AFTER the callback is called.  Calling it one-twentieth
// of a second later should fix that.
function vehMount() {
  schedule(50, 0, vehPilot);
}

// function to handle a player jumping in as a vehicle pilot
function vehPilot() {
  if ($TruPref::transVehChatOn == 1 || ($TruPref::transVehChatOn == 2 && getCurrentPosition() $= "Pilot")) {
    $tvcPlayerPilot = true;
    setChatTransparent(true);
  }
}

// function to handle player jumping out of vehicle
function vehDismount() {
  if ($tvcPlayerPilot)
    setChatTransparent(false);

  $tvcPlayerPilot = false;
}

// function to change the chat's transparency
function setChatTransparent(%trans) {
  if (%trans)
    outerChatHud.setProfile("GuiModelessDialogProfile");      // back not visible
  else
    outerChatHud.setProfile("GuiChatBackProfile");            // back visible

  // profile wont change until we refresh the chat object
  Canvas.popDialog(MainChatHud);
  Canvas.pushDialog(MainChatHud);
  chatHud.attach(HudMessageVector);
}

initTransVehChat();
